###############################################################################
###############################################################################
##
##  Copyright (C) 2006-2007 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################


%define include_zope_and_plone     yes



############  SRPM  ###################


Name: conga
Version: 0.9.2
Release: 6%{?dist}.0.1
License: GPL
URL: http://sources.redhat.com/cluster/conga

Group: System Environment/Base
Summary: Remote Management System

Source0: %{name}-%{version}.tar.gz
%if "%{include_zope_and_plone}" == "yes"
Source1: Zope-2.9.7-final.tgz
Source2: Plone-2.5.2-1.tar.gz
Patch2: Plone-2.5.2-1_CMFPlone.patch
%endif
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


BuildRequires: python-devel >= 2.4.1
BuildRequires: glibc-devel gcc-c++ libxml2-devel sed
#BuildRequires: pam-devel
BuildRequires: cyrus-sasl-devel >= 2.1
BuildRequires: openssl-devel dbus-devel pkgconfig file


%description
Conga is a project developing management system for remote stations. 
It consists of luci, https frontend, and ricci, secure daemon that dispatches 
incoming messages to underlying management modules. 


%prep
%setup -q
%if "%{include_zope_and_plone}" == "yes"
# Zope
%setup -q -T -D -a 1
ln -s ../Zope-2.9.7-final luci/zope
# Plone
%setup -q -T -D -a 2
ln -s ../Plone-2.5.2-1 luci/plone
pushd luci/plone
%patch2 -p1
popd
%endif

%build
%configure      --arch=%{_arch} \
		--docdir=%{_docdir} \
		--include_zope_and_plone=%{include_zope_and_plone}
make %{?_smp_mflags} conga

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install_conga

%clean
rm -rf $RPM_BUILD_ROOT







#######  luci  #######


%package -n luci

Group: System Environment/Base
Summary: Remote Management System - Management Station

Requires: chkconfig initscripts
Requires: python >= 2.4.1
%if "%{include_zope_and_plone}" == "yes"
Provides: config(luci) = %{version}-%{release}
# don't provide zope internals
AutoProv: no
%else
AutoProv: yes
Requires: zope
Requires: plone >= 2.5
%endif
Requires: grep openssl mailcap stunnel 
Requires: sed util-linux

Requires(pre): grep shadow-utils
Requires(post): chkconfig initscripts
Requires(preun): chkconfig initscripts


%description -n luci
Conga is a project developing management system for remote stations. 
It consists of luci, https frontend, and ricci, secure daemon that 
dispatches incoming messages to underlying management modules. 

This package contains Luci website.


%files -n luci
%defattr(-,root,root)
%config(noreplace)		%{_sysconfdir}/sysconfig/luci
				%{_sysconfdir}/rc.d/init.d/luci
				%{_sbindir}/luci_admin
				%{_docdir}/luci-%{version}/
%defattr(-,luci,luci)
				%{_localstatedir}/lib/luci
				%{_libdir}/luci/ssl
%if "%{include_zope_and_plone}" == "yes"
				%{_libdir}/luci/zope
%endif

%pre -n luci
if ! /bin/grep luci\:x /etc/group 2>&1 >/dev/null; then
   /usr/sbin/groupadd -r -f luci >/dev/null 2>&1
fi
if ! /bin/grep luci\:x /etc/passwd 2>&1 >/dev/null; then
   /usr/sbin/useradd -r -M -s /sbin/nologin -d /var/lib/luci -g luci luci >/dev/null 2>&1
fi

%post -n luci
/sbin/chkconfig --add luci
/sbin/service luci status >/dev/null 2>&1
LUCI_RUNNING=$?
if [ "$LUCI_RUNNING" == "0" ]; then
   /sbin/service luci stop >/dev/null 2>&1
fi
if [ -e /var/lib/luci/var/luci_backup.xml ]; then
   # restore luci database
   /usr/sbin/luci_admin restore >/dev/null 2>&1
fi
# set initial admin password (if not already set) to random value
if ! /bin/grep True /var/lib/luci/.default_password_has_been_reset 2>&1 >/dev/null; then
   /usr/sbin/luci_admin password --random >/dev/null 2>&1
fi
if [ "$LUCI_RUNNING" == "0" ]; then
   /sbin/service luci start >/dev/null 2>&1
fi

%preun -n luci
if [ "$1" == "0" ]; then
   /sbin/service luci stop >/dev/null 2>&1
   /sbin/chkconfig --del luci
fi
/sbin/service luci status >/dev/null 2>&1
LUCI_RUNNING=$?
if [ "$LUCI_RUNNING" == "0" ]; then
   /sbin/service luci stop >/dev/null 2>&1
fi
/usr/sbin/luci_admin backup >/dev/null 2>&1
if [ "$LUCI_RUNNING" == "0" ]; then
   /sbin/service luci start >/dev/null 2>&1
fi




### ricci daemon & basic modules ###


%package -n ricci

Group: System Environment/Base
Summary: Remote Management System - Managed Station

Requires: initscripts
Requires: oddjob dbus openssl pam cyrus-sasl >= 2.1
Requires: sed util-linux
Requires: modcluster >= 0.8

# modreboot

# modrpm

# modstorage
Requires: parted util-linux

# modservice
Requires: chkconfig initscripts

# modlog


Requires(pre): grep shadow-utils
Requires(post): chkconfig initscripts util-linux
Requires(preun): chkconfig initscripts
Requires(postun): initscripts util-linux

%description -n ricci
Conga is a project developing management system for remote stations. 
It consists of luci, https frontend, and ricci, secure daemon that dispatches 
incoming messages to underlying management modules. 

This package contains listening daemon (dispatcher), as well as 
reboot, rpm, storage, service and log management modules. 


%files -n ricci
%defattr(-,root,root)
# ricci
%config(noreplace)	%{_sysconfdir}/pam.d/ricci
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci.systembus.conf
			%{_sysconfdir}/rc.d/init.d/ricci
%attr(-,ricci,ricci)	%{_localstatedir}/lib/ricci
			%{_sbindir}/ricci
%attr(-,root,ricci)	%{_libexecdir}/ricci/
			%{_docdir}/ricci-%{version}/
# modrpm
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modrpm.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modrpm.systembus.conf
			%{_libexecdir}/ricci-modrpm
# modstorage
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modstorage.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modstorage.systembus.conf
			%{_libexecdir}/ricci-modstorage
# modservice
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modservice.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modservice.systembus.conf
			%{_libexecdir}/ricci-modservice
# modlog
%config(noreplace)	%{_sysconfdir}/oddjobd.conf.d/ricci-modlog.oddjob.conf
%config(noreplace)	%{_sysconfdir}/dbus-1/system.d/ricci-modlog.systembus.conf
			%{_libexecdir}/ricci-modlog

%pre -n ricci
if ! /bin/grep ricci\:x /etc/group 2>&1 >/dev/null; then
   /usr/sbin/groupadd -r -f ricci >/dev/null 2>&1
fi
if ! /bin/grep ricci\:x /etc/passwd 2>&1 >/dev/null; then
   /usr/sbin/useradd -r -M -s /sbin/nologin -d /var/lib/ricci -g ricci ricci >/dev/null 2>&1
fi

%post -n ricci
/sbin/chkconfig --add ricci
DBUS_PID=`cat /var/run/messagebus.pid 2> /dev/null`
/bin/kill -s SIGHUP $DBUS_PID > /dev/null 2>&1
/sbin/service oddjobd reload >/dev/null 2>&1

%preun -n ricci
if [ "$1" == "0" ]; then
   /sbin/service ricci stop > /dev/null 2>&1
   /sbin/chkconfig --del ricci
fi

%postun -n ricci
if [ "$1" == "0" ]; then
   DBUS_PID=`cat /var/run/messagebus.pid 2> /dev/null`
   /bin/kill -s SIGHUP $DBUS_PID > /dev/null 2>&1
   /sbin/service oddjobd reload > /dev/null 2>&1
fi
if [ "$1" == "1" ]; then
   /sbin/service ricci condrestart > /dev/null 2>&1
fi





###  changelog ###


%changelog
* Mon Jun 25 2007 Kevin Lyons <kevin.x.lyons@redhat.com> 0.9.2-6.0.1
- Replaced RedHat copyrighted and trademarked images in the conga-0.9.2 tarball.

* Thu Apr 12 2007 Ryan McCabe <rmccabe@redhat.com> 0.9.2-6
- Fixed bz233326 (CVE-2007-0240 Conga includes version of Zope that is vulnerable to a XSS attack)
- Fixed bz228637 (CVE-2007-1462 security alert - passwords sent back from server as input value)
- Fixed bz236020 (Conga allows creation/rename of clusters with name greater than 15 characters)
- Fixed bz236021 (Cluster cannot be deleted (from 'Manage Systems') - but no error results)
- Fixed bz236025 (Entering bad password when creating a new cluster = UnboundLocalError: local variable 'e' referenced before assignment)
- Fixed bz236026 (luci failover domain forms are missing/empty)
- Fixed bz236027 (fence_xvm is incorrectly listed as "xmv" in virtual cluster)
- Fixed bz236048 (Advanced options parameters settings don't do anything)
- Fixed bz236050 (Unable to configure a virtual service)
- Fixed bz236052 (kmod-gfs-xen not installed with Conga install)
- Fixed bz236054 (enable shared storage' option cleared whenever there is a configuration error)
- Fixed bz236055 (Must manually edit cluster.conf on the dom0 cluster to add "<fence_xvmd/>")
- Resolves: bz233326, bz228637, bz236020, bz236021, bz236025, bz236026,
- Resolves: bz236027, bz236048, bz236050, bz236052, bz236054, bz236055
- Related: bz236023

* Tue Jan 23 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-30
- Fixed bz212445 (release blocker: prevent management page access)
- Resolves: bz212445

* Wed Jan 17 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-29
- Remove test accounts from Data.fs
- Related: bz222223

* Wed Jan 17 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-28
- Updated docs
- Fixed bz222223 (Deactivate LV before removal)
- Resolves: bz222223

* Wed Jan 10 2007 Stanko Kupcevic <kupcevic@redhat.com> 0.8-27
- Fixed bz214989 (Package download not working for Conga during cluster creation)
- Fixed bz219522 (Restarting a cluster via luci web gui = UnboundLocalError - local variable 'e' referenced before assignment)
- Fixed bz201394 (luci doesn't verify ricci's SSL cert against trusted list)
- Fixed bz212021 (various luci buttons do nothing)
- Fixed bz212448 (release blocker: turn off debug mode of server)
- Fixed bz212445 (release blocker: prevent management page access)

* Tue Dec 12 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-26
- luci storage: fix bytes->TB conversion
- Improved bz201394: luci doesn't verify ricci's SSL cert against trusted list (step 1 - backend)
- Fixed bz217387 (luci - HTML error shows up in display (minor))
- Fixed bz215031 (Cannot add a resource to a service via luci web app)
- Fixed bz218040 (luci reports "unknown" as cluster name if cluster creation fails)
- Fixed bz218941 (Conga/luci - cannot add node to cluster via luci web app)
- Fixed bz219156 (Errors in performing node-specific tasks due to ricci outage not reflected in luci display)
- Fixed bz217703 (clustered vg creation fails)
- Resolves: bz217387, bz215031, bz218040, bz218941, bz219156, bz217703
- Related: bz201394

* Thu Nov 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-25
- Fix build issues (D-BUS detection)

* Thu Nov 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-24
- Fixed bz215039 (Cannot create a new resource via luci web app)
- Fixed bz215034 (Cannot change daemon properties via luci web app)
- Fixed bz214790 (Stop/restart cluster not working via luci web app)
- Fixed bz213690 (luci - Reversed links in colophon (gui - minor))
- Fixed bz213266 (Conga - modifying a cluster node's cluster membership in a subnet with other clusters results in the wrong cluster.conf)
- Fixed bz213083 (luci - should display usernames in some logical/sorted order (usability))
- Fixed bz212601 (luci - selecting cluster name or cluster node name indicates error in install and displays empty form)
- Fixed bz212021 (various luci buttons do nothing)
- Fixed bz212006 (create cluster does not show status as cluster is being created)
- Fixed bz212584 (luci does not retrieve failed ricci queue elements)
- Fixed bz212440 (luci persists possibly incorrect name for a system)
- Improved bz213306 (ricci - log probing can take minutes to complete)
- Fixed starting/stopping services
- Fixed deleting cluster
- Fixed deleting node
- Fixed redirection for all async->busy wait calls
- Storage module: properly probe cluster quorum if LVM locking 
  is marked as clustered
- Resolves: bz215039, bz215034, bz214790, bz213690, bz213266
- Resolves: bz213083, bz212601, bz212021, bz212006, bz212584
- Resolves: bz212440
- Related: bz213306

* Wed Nov 01 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-23
- 213504: luci does not correctly handle cluster.conf with 
  nodes lacking FQDN

* Tue Oct 31 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-22
- 212582: SELinux prevents creation of /etc/cluster/cluster.conf

* Wed Oct 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-21
- 211564: ricci allocates huge memory chunk, causing long swapping
- 211345: cluster_adapters is missing import of Xenvm module
- 211191: SELinux issues tracking bug
- 211370: retrieving log from node fails
- 211942: Xenvm moniker must be eradicated from UI
- 211375: unable to reliably create a cluster
- 211373: reboot node fails from storage tab

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-20
- Minor GUI nits

* Wed Oct 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-19
- GUI nits
- Fixed bzs: 206663, 206567, 206571, 206572

* Wed Oct 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-18
- Version bump

* Wed Oct 04 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-17
- Many luci improvements

* Mon Sep 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-16
- Enable zope/plone inclusion on RHELs
- Remove luci's dependency on ricci
- Many improvements of cluster management interface
- Add full GFS1/2 support; detect many other filesystems
- Suppress msgs from init script (bz204235)
- Upgrade zope to 2.9.4 (track Fedora Core)

* Thu Aug 24 2006 Paul Nasrat <pnasrat@redhat.com> 0.8-15
- Disable inclusion of plone/zope and comment out requires

* Fri Aug 21 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-14
- Version bump

* Fri Aug 18 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-13
- Version bump

* Fri Aug 18 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-12
- Don't auto-start ricci after installation, do it manually
- Under certain circumstances, default luci password would not get reset
- Many Luci improvements   

* Wed Aug 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-11.7
- Move ricci-modrpm, ricci-modlog, ricci-modstorage, ricci-modservice
   from /usr/sbin to /usr/libexec

* Wed Aug 09 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-11
- Spin off clustermon.srpm (modcluster, cluster-snmp and 
   cluster-cim) from conga.srpm
- Luci: tighten down security

* Thu Aug 03 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-10
- Luci: fix login issues, add cluster resources, styling... 

* Wed Jul 26 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-9
- Update Luci to Plone 2.5

* Tue Jul 25 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-8
- New build with a lot of implementation details on Luci
- Last build with plone 2.1.2

* Thu Jul 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-7
- More compliant specfile, minor fixes

* Tue Jun 27 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-6
- Luci persists users/clusters/systems/permissions across upgrades 

* Fri Jun 16 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-4
- Moved storage, service, log and rpm modules into main ricci.rpm

* Wed Jun 14 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.8-1
- Packaged cluster-snmp (cluster snmp agent)
- Packaged cluster-cim (cluster CIM provider)

* Mon Jun 06 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.7-5
- Disable non-https access to Luci, enable https on port 8084

* Mon Jun 02 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.7-1
- Packaged Luci - ricci's www frontend
- Added logging module

* Mon May 26 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.6-1
- Multitude of fixes and new features

* Mon Apr 10 2006 Stanko Kupcevic <kupcevic@redhat.com> 0.5-1
- First official build of conga project
